--- src/C/testcasesupport/std_testcase.h	2017-08-29 23:30:51.000000000 +0200
+++ src/C/testcasesupport/std_testcase_mopsa.h	2020-03-19 20:51:18.006392560 +0100
@@ -80,17 +80,13 @@
 
 #endif /* end ifndef __cplusplus */
 
-/* rand only returns 15 bits, so we xor 3 calls together to get the full result (13 bits overflow, but that is okay) */
-// shifting signed values might overflow and be undefined
-#define URAND31() (((unsigned)rand()<<30) ^ ((unsigned)rand()<<15) ^ rand())
-// choose to produce a positive or a negative number. Note: conditional only evaluates one URAND31
-#define RAND32() ((int)(rand() & 1 ? URAND31() : -URAND31() - 1))
-
-/* rand only returns 15 bits, so we xor 5 calls together to get the full result (11 bits overflow, but that is okay) */
-// shifting signed values might overflow and be undefined
-#define URAND63() (((uint64_t)rand()<<60) ^ ((uint64_t)rand()<<45) ^ ((uint64_t)rand()<<30) ^ ((uint64_t)rand()<<15) ^ rand())
-// choose to produce a positive or a negative number. Note: conditional only evaluates one URAND63
-#define RAND64() ((int64_t)(rand() & 1 ? URAND63() : -URAND63() - 1))
+#define URAND31() (_mopsa_rand_u32() >> 1)
+
+#define RAND32() (_mopsa_rand_s32())
+
+#define URAND63() (_mopsa_rand_u64())
+
+#define RAND64() (_mopsa_rand_s64())
 
 /* struct used in some test cases as a custom type */
 typedef struct _twoIntsStruct
